Index: /palm/trunk/SCRIPTS/palmrungui
===================================================================
--- /palm/trunk/SCRIPTS/palmrungui	(revision 4788)
+++ /palm/trunk/SCRIPTS/palmrungui	(revision 4789)
@@ -20,9 +20,14 @@
 # Current revisions:
 # -----------------
-# 
-# 
+#
+#
 # Former revisions:
 # -----------------
 # $Id$
+# Bugfix: set check boxes for cyclic fill and svf I/O when loading job from history.
+# Added support for option -W (wait for job; dependency mode)
+#
+# 
+# 4670 2020-09-09 17:27:45Z maronga
 # Ported to PyQt5, removed support for user parameters. Added support for Option
 # "-V" (do not re-build pre-built source code). Changed activation strings
@@ -691,5 +696,9 @@
             tmptext = self.group_execution.findChild(QtWidgets.QLineEdit,"line_account").text()
             self.change_commandline("A",tmptext)
-        
+
+        elif ( self.sender() == self.group_execution.findChild(QtWidgets.QLineEdit,"line_wait")):
+            tmptext = self.group_execution.findChild(QtWidgets.QLineEdit,"line_wait").text()
+            self.change_commandline("W",tmptext)
+
         elif ( self.sender() ==  self.group_execution.findChild(QtWidgets.QLineEdit,"line_pe")):
             tmptext = self.group_execution.findChild(QtWidgets.QLineEdit,"line_pe").text()
@@ -786,5 +795,5 @@
             self.deactivate_flag("B")
     
-        status = self.group_execution.findChild(QtWidgets.QCheckBox,"check_verbose" ).checkState()
+        status = self.groupBox.findChild(QtWidgets.QCheckBox,"check_verbose" ).checkState()
         if (status == 2):
             self.activate_flag("v") 
@@ -961,5 +970,8 @@
             elif ( parameter == "A"):
                 self.group_execution.findChild(QtWidgets.QLineEdit,"line_account").setText(options)
-             
+
+            elif ( parameter == "W"):
+                self.group_execution.findChild(QtWidgets.QLineEdit,"line_wait").setText(options)
+
             elif ( parameter == "X"):
                 self.group_execution.findChild(QtWidgets.QLineEdit,"line_pe").setText(options)
@@ -975,5 +987,5 @@
              
             elif ( parameter == "v"):
-                self.group_execution.findChild(QtWidgets.QCheckBox,"check_verbose").setChecked(True)
+                self.groupBox.findChild(QtWidgets.QCheckBox,"check_verbose").setChecked(True)
                           
             elif ( parameter == "b"): 
@@ -1073,4 +1085,13 @@
                         self.group_execution.findChild(QtWidgets.QCheckBox,"check_restarts").setChecked(True)
 
+                    if (options_all == "rec"):
+                        self.group_execution.findChild(QtWidgets.QCheckBox,"check_cycfill").setChecked(True)
+
+                    if (options_all == "svfin"):
+                        self.group_execution.findChild(QtWidgets.QCheckBox,"check_svf").setChecked(True)
+
+                    if (options_all == "svfout"):
+                        self.group_execution.findChild(QtWidgets.QCheckBox,"check_svf_2").setChecked(True)
+
                     j = j+1
             i = i-1
Index: /palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui
===================================================================
--- /palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 4788)
+++ /palm/trunk/SCRIPTS/palmrungui_files/mainwindow.ui	(revision 4789)
@@ -14,5 +14,5 @@
     <y>0</y>
     <width>1185</width>
-    <height>800</height>
+    <height>850</height>
    </rect>
   </property>
@@ -26,5 +26,5 @@
    <size>
     <width>1185</width>
-    <height>800</height>
+    <height>850</height>
    </size>
   </property>
@@ -32,5 +32,5 @@
    <size>
     <width>1185</width>
-    <height>800</height>
+    <height>850</height>
    </size>
   </property>
@@ -67,5 +67,5 @@
      <rect>
       <x>0</x>
-      <y>680</y>
+      <y>720</y>
       <width>1181</width>
       <height>81</height>
@@ -84,7 +84,7 @@
      <property name="geometry">
       <rect>
-       <x>150</x>
+       <x>350</x>
        <y>15</y>
-       <width>90</width>
+       <width>91</width>
        <height>26</height>
       </rect>
@@ -102,5 +102,5 @@
        <x>10</x>
        <y>15</y>
-       <width>131</width>
+       <width>121</width>
        <height>26</height>
       </rect>
@@ -124,5 +124,5 @@
        <x>250</x>
        <y>15</y>
-       <width>90</width>
+       <width>91</width>
        <height>26</height>
       </rect>
@@ -166,7 +166,7 @@
      <property name="geometry">
       <rect>
-       <x>470</x>
+       <x>550</x>
        <y>20</y>
-       <width>701</width>
+       <width>621</width>
        <height>21</height>
       </rect>
@@ -179,5 +179,5 @@
      <property name="geometry">
       <rect>
-       <x>370</x>
+       <x>460</x>
        <y>20</y>
        <width>81</width>
@@ -205,4 +205,17 @@
      </property>
     </widget>
+    <widget class="QCheckBox" name="check_verbose">
+     <property name="geometry">
+      <rect>
+       <x>140</x>
+       <y>20</y>
+       <width>111</width>
+       <height>23</height>
+      </rect>
+     </property>
+     <property name="text">
+      <string>Silent mode</string>
+     </property>
+    </widget>
    </widget>
    <widget class="QTabWidget" name="tabWidget">
@@ -212,5 +225,5 @@
       <y>-5</y>
       <width>1181</width>
-      <height>696</height>
+      <height>731</height>
      </rect>
     </property>
@@ -248,5 +261,5 @@
         <y>350</y>
         <width>441</width>
-        <height>311</height>
+        <height>351</height>
        </rect>
       </property>
@@ -264,5 +277,5 @@
         <rect>
          <x>330</x>
-         <y>60</y>
+         <y>180</y>
          <width>101</width>
          <height>21</height>
@@ -280,5 +293,5 @@
         <rect>
          <x>250</x>
-         <y>61</y>
+         <y>180</y>
          <width>71</width>
          <height>20</height>
@@ -297,5 +310,5 @@
          <x>130</x>
          <y>150</y>
-         <width>91</width>
+         <width>81</width>
          <height>20</height>
         </rect>
@@ -353,6 +366,6 @@
        <property name="geometry">
         <rect>
-         <x>330</x>
-         <y>180</y>
+         <x>130</x>
+         <y>210</y>
          <width>101</width>
          <height>20</height>
@@ -366,6 +379,6 @@
        <property name="geometry">
         <rect>
-         <x>260</x>
-         <y>180</y>
+         <x>60</x>
+         <y>210</y>
          <width>61</width>
          <height>16</height>
@@ -400,5 +413,5 @@
          <x>130</x>
          <y>180</y>
-         <width>91</width>
+         <width>101</width>
          <height>20</height>
         </rect>
@@ -411,6 +424,6 @@
        <property name="geometry">
         <rect>
-         <x>30</x>
-         <y>90</y>
+         <x>10</x>
+         <y>60</y>
          <width>91</width>
          <height>21</height>
@@ -431,5 +444,5 @@
         <rect>
          <x>10</x>
-         <y>200</y>
+         <y>230</y>
          <width>411</width>
          <height>20</height>
@@ -444,5 +457,5 @@
         <rect>
          <x>10</x>
-         <y>210</y>
+         <y>280</y>
          <width>121</width>
          <height>23</height>
@@ -457,24 +470,11 @@
         <rect>
          <x>10</x>
-         <y>230</y>
-         <width>281</width>
+         <y>300</y>
+         <width>161</width>
          <height>23</height>
         </rect>
        </property>
        <property name="text">
-        <string>Do not delete temporary directory at end</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_verbose">
-       <property name="geometry">
-        <rect>
-         <x>10</x>
-         <y>250</y>
-         <width>261</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>No prompt on confirmation (silent)</string>
+        <string>Keep temporary data</string>
        </property>
       </widget>
@@ -482,7 +482,7 @@
        <property name="geometry">
         <rect>
-         <x>10</x>
-         <y>270</y>
-         <width>261</width>
+         <x>220</x>
+         <y>280</y>
+         <width>201</width>
          <height>21</height>
         </rect>
@@ -495,6 +495,6 @@
        <property name="geometry">
         <rect>
-         <x>10</x>
-         <y>290</y>
+         <x>220</x>
+         <y>300</y>
          <width>261</width>
          <height>21</height>
@@ -512,5 +512,5 @@
         <rect>
          <x>60</x>
-         <y>60</y>
+         <y>250</y>
          <width>191</width>
          <height>26</height>
@@ -577,5 +577,5 @@
         <rect>
          <x>10</x>
-         <y>60</y>
+         <y>250</y>
          <width>41</width>
          <height>21</height>
@@ -620,6 +620,6 @@
        <property name="geometry">
         <rect>
-         <x>230</x>
-         <y>120</y>
+         <x>210</x>
+         <y>90</y>
          <width>91</width>
          <height>21</height>
@@ -633,16 +633,16 @@
        <property name="geometry">
         <rect>
-         <x>130</x>
+         <x>110</x>
+         <y>60</y>
+         <width>321</width>
+         <height>26</height>
+        </rect>
+       </property>
+      </widget>
+      <widget class="QCheckBox" name="check_rebuild">
+       <property name="geometry">
+        <rect>
+         <x>330</x>
          <y>90</y>
-         <width>301</width>
-         <height>26</height>
-        </rect>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_rebuild">
-       <property name="geometry">
-        <rect>
-         <x>330</x>
-         <y>120</y>
          <width>101</width>
          <height>22</height>
@@ -656,6 +656,6 @@
        <property name="geometry">
         <rect>
-         <x>130</x>
-         <y>120</y>
+         <x>110</x>
+         <y>90</y>
          <width>91</width>
          <height>21</height>
@@ -669,25 +669,57 @@
        <property name="geometry">
         <rect>
+         <x>110</x>
+         <y>120</y>
+         <width>191</width>
+         <height>23</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Use pre-built source code</string>
+       </property>
+      </widget>
+      <widget class="QCheckBox" name="check_svf_2">
+       <property name="geometry">
+        <rect>
+         <x>220</x>
+         <y>320</y>
+         <width>201</width>
+         <height>21</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Write sky view factors to file</string>
+       </property>
+      </widget>
+      <widget class="QLabel" name="label_20">
+       <property name="geometry">
+        <rect>
          <x>240</x>
          <y>210</y>
-         <width>191</width>
-         <height>23</height>
-        </rect>
-       </property>
-       <property name="text">
-        <string>Use pre-built source code</string>
-       </property>
-      </widget>
-      <widget class="QCheckBox" name="check_svf_2">
-       <property name="geometry">
-        <rect>
-         <x>240</x>
-         <y>290</y>
-         <width>201</width>
+         <width>81</width>
+         <height>20</height>
+        </rect>
+       </property>
+       <property name="text">
+        <string>Wait for job:</string>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignBottom|Qt::AlignRight|Qt::AlignTrailing</set>
+       </property>
+      </widget>
+      <widget class="QLineEdit" name="line_wait">
+       <property name="geometry">
+        <rect>
+         <x>330</x>
+         <y>210</y>
+         <width>101</width>
          <height>21</height>
         </rect>
        </property>
        <property name="text">
-        <string>Write sky view factors to file</string>
+        <string/>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
        </property>
       </widget>
@@ -728,5 +760,5 @@
         <y>5</y>
         <width>721</width>
-        <height>656</height>
+        <height>691</height>
        </rect>
       </property>
@@ -743,5 +775,5 @@
          <y>90</y>
          <width>231</width>
-         <height>561</height>
+         <height>591</height>
         </rect>
        </property>
@@ -762,5 +794,5 @@
          <y>90</y>
          <width>231</width>
-         <height>141</height>
+         <height>171</height>
         </rect>
        </property>
@@ -782,5 +814,5 @@
         <rect>
          <x>250</x>
-         <y>250</y>
+         <y>280</y>
          <width>231</width>
          <height>141</height>
@@ -830,5 +862,5 @@
         <rect>
          <x>250</x>
-         <y>230</y>
+         <y>260</y>
          <width>156</width>
          <height>16</height>
@@ -858,5 +890,5 @@
          <y>90</y>
          <width>221</width>
-         <height>561</height>
+         <height>591</height>
         </rect>
        </property>
@@ -891,5 +923,5 @@
         <rect>
          <x>250</x>
-         <y>420</y>
+         <y>450</y>
          <width>231</width>
          <height>231</height>
@@ -913,5 +945,5 @@
         <rect>
          <x>250</x>
-         <y>395</y>
+         <y>430</y>
          <width>156</width>
          <height>16</height>
@@ -1403,6 +1435,6 @@
     <property name="geometry">
      <rect>
-      <x>267</x>
-      <y>152</y>
+      <x>195</x>
+      <y>230</y>
       <width>155</width>
       <height>137</height>
@@ -1549,6 +1581,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>160</x>
-     <y>756</y>
+     <x>360</x>
+     <y>804</y>
     </hint>
     <hint type="destinationlabel">
@@ -1566,5 +1598,5 @@
     <hint type="sourcelabel">
      <x>73</x>
-     <y>756</y>
+     <y>804</y>
     </hint>
     <hint type="destinationlabel">
@@ -1581,6 +1613,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>214</x>
-     <y>500</y>
+     <x>218</x>
+     <y>695</y>
     </hint>
     <hint type="destinationlabel">
@@ -1597,6 +1629,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>252</x>
-     <y>500</y>
+     <x>254</x>
+     <y>695</y>
     </hint>
     <hint type="destinationlabel">
@@ -1613,6 +1645,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>82</x>
-     <y>630</y>
+     <x>86</x>
+     <y>722</y>
     </hint>
     <hint type="destinationlabel">
@@ -1629,6 +1661,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>86</x>
-     <y>650</y>
+     <x>90</x>
+     <y>742</y>
     </hint>
     <hint type="destinationlabel">
@@ -1645,6 +1677,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>67</x>
-     <y>670</y>
+     <x>197</x>
+     <y>806</y>
     </hint>
     <hint type="destinationlabel">
@@ -1789,6 +1821,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>406</x>
-     <y>495</y>
+     <x>410</x>
+     <y>620</y>
     </hint>
     <hint type="destinationlabel">
@@ -1805,6 +1837,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>425</x>
-     <y>615</y>
+     <x>229</x>
+     <y>649</y>
     </hint>
     <hint type="destinationlabel">
@@ -1902,5 +1934,5 @@
     <hint type="sourcelabel">
      <x>299</x>
-     <y>756</y>
+     <y>804</y>
     </hint>
     <hint type="destinationlabel">
@@ -2077,6 +2109,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>178</x>
-     <y>710</y>
+     <x>392</x>
+     <y>740</y>
     </hint>
     <hint type="destinationlabel">
@@ -2205,6 +2237,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>246</x>
-     <y>560</y>
+     <x>230</x>
+     <y>530</y>
     </hint>
     <hint type="destinationlabel">
@@ -2221,6 +2253,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>138</x>
-     <y>530</y>
+     <x>122</x>
+     <y>505</y>
     </hint>
     <hint type="destinationlabel">
@@ -2237,10 +2269,10 @@
    <hints>
     <hint type="sourcelabel">
-     <x>157</x>
-     <y>555</y>
+     <x>141</x>
+     <y>530</y>
     </hint>
     <hint type="destinationlabel">
      <x>397</x>
-     <y>-4</y>
+     <y>0</y>
     </hint>
    </hints>
@@ -2258,5 +2290,5 @@
     <hint type="destinationlabel">
      <x>538</x>
-     <y>-4</y>
+     <y>0</y>
     </hint>
    </hints>
@@ -2269,10 +2301,10 @@
    <hints>
     <hint type="sourcelabel">
-     <x>333</x>
-     <y>639</y>
+     <x>207</x>
+     <y>562</y>
     </hint>
     <hint type="destinationlabel">
      <x>580</x>
-     <y>-2</y>
+     <y>0</y>
     </hint>
    </hints>
@@ -2290,5 +2322,5 @@
     <hint type="destinationlabel">
      <x>728</x>
-     <y>-3</y>
+     <y>0</y>
     </hint>
    </hints>
@@ -2301,10 +2333,26 @@
    <hints>
     <hint type="sourcelabel">
-     <x>363</x>
-     <y>721</y>
+     <x>347</x>
+     <y>760</y>
     </hint>
     <hint type="destinationlabel">
      <x>831</x>
-     <y>-2</y>
+     <y>0</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>line_wait</sender>
+   <signal>textEdited(QString)</signal>
+   <receiver>MainWindow</receiver>
+   <slot>change_lineinput()</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>371</x>
+     <y>637</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>573</x>
+     <y>-6</y>
     </hint>
    </hints>