Index: /palm/trunk/SCRIPTS/.palm.config.atosg
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosg	(revision 4797)
+++ /palm/trunk/SCRIPTS/.palm.config.atosg	(revision 4798)
@@ -3,5 +3,5 @@
 #name of variable  value of variable (~ must not be used)
 #----------------------------------------------------------------------------
-%base_data           ~/palm/current_version/JOBS
+%base_data           $HOME/palm/current_version/JOBS
 %base_directory      $HOME/palm/current_version
 %source_path         $HOME/palm/current_version/trunk/SOURCE
@@ -17,5 +17,5 @@
 %remote_username     <replace_by_your_HLRN_username>
 %ssh_key             id_rsa_hlrn
-%defaultqueue        medium40:test
+%defaultqueue        standard96:test
 %submit_command      /cm/shared/batch/bin/sbatch
 
@@ -24,7 +24,7 @@
 %cpp_options         -cpp -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__netcdf -D__netcdf4 -D__netcdf4_parallel -D__intel_compiler -D__fftw
 %make_options        -j 4
-%compiler_options    -fpe0 -O3 -fp-model source -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/4.6.3/skl/intel.18_mpi/include -I /home/bekklaus/opt/fftw3_intel18/include
-%linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L/home/bekklaus/opt/fftw3_intel18/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
+%compiler_options    -fpe0 -O3 -fp-model source -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/intel.18/4.7.3/skl/include/ -I /sw/numerics/fftw3/impi/intel/3.3.8/skl/include/
+%linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L /sw/numerics/fftw3/impi/intel/3.3.8/skl/lib -lfftw3
+%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/19.1.2 impi  netcdf-parallel/impi/intel fftw3/impi/intel
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x
@@ -62,4 +62,6 @@
 IC:export I_MPI_FABRICS=shm:ofi
 IC:export I_MPI_OFI_PROVIDER=psm2
+IC:export I_MPI_ADJUST_ALLTOALL=3
+IC:export I_MPI_HYDRA_BRANCH_COUNT=128
 IC:module list
 
Index: /palm/trunk/SCRIPTS/.palm.config.atosg_debug
===================================================================
--- /palm/trunk/SCRIPTS/.palm.config.atosg_debug	(revision 4797)
+++ /palm/trunk/SCRIPTS/.palm.config.atosg_debug	(revision 4798)
@@ -3,5 +3,5 @@
 #name of variable  value of variable (~ must not be used)
 #----------------------------------------------------------------------------
-%base_data           ~/palm/current_version/JOBS
+%base_data           $HOME/palm/current_version/JOBS
 %base_directory      $HOME/palm/current_version
 %source_path         $HOME/palm/current_version/trunk/SOURCE
@@ -17,5 +17,5 @@
 %remote_username     <replace_by_your_HLRN_username>
 %ssh_key             id_rsa_hlrn
-%defaultqueue        medium40:test
+%defaultqueue        standard96:test
 %submit_command      /cm/shared/batch/bin/sbatch
 
@@ -24,7 +24,7 @@
 %cpp_options         -cpp -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__netcdf -D__netcdf4 -D__netcdf4_parallel -D__intel_compiler -D__fftw
 %make_options        -j 4
-%compiler_options    -fpe0 -check -check nooutput_conversion -traceback -g -O0 -align all -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/4.6.3/skl/intel.18_mpi/include -I /home/bekklaus/opt/fftw3_intel18/include
-%linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L/home/bekklaus/opt/fftw3_intel18/lib -lfftw3
-%module_commands     module use /sw/modules/HLRN; module purge; module load HLRNenv sw.skl slurm intel/18.0.5 impi/2018.4 netcdf/4.6.3_intel.18_impi
+%compiler_options    -fpe0 -check -check nooutput_conversion -traceback -g -O0 -align all -ftz -xCORE-AVX512 -no-prec-div -no-prec-sqrt -ip -convert little_endian -I /sw/dataformats/netcdf/intel.18/4.7.3/skl/include/ -I /sw/numerics/fftw3/impi/intel/3.3.8/skl/include/
+%linker_options      -Wl,-rpath=\\$LD_RUN_PATH \\`nf-config --flibs\\` -L /sw/numerics/fftw3/impi/intel/3.3.8/skl/lib -lfftw3
+%module_commands     module use /sw/modules/HLRN; module load HLRNenv sw.skl slurm intel/19.1.2 impi  netcdf-parallel/impi/intel fftw3/impi/intel
 %execute_command     srun --propagate=STACK --kill-on-bad-exit -n {{mpi_tasks}} -N {{nodes}} --ntasks-per-node={{tasks_per_node}}  palm
 %execute_command_for_combine   srun --propagate=STACK -n 1 --ntasks-per-node=1  combine_plot_fields.x
@@ -62,4 +62,6 @@
 IC:export I_MPI_FABRICS=shm:ofi
 IC:export I_MPI_OFI_PROVIDER=psm2
+IC:export I_MPI_ADJUST_ALLTOALL=3
+IC:export I_MPI_HYDRA_BRANCH_COUNT=128
 IC:module list
 