Index: palm/trunk/UTIL/inifor/src/inifor.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor.f90	(revision 4807)
+++ palm/trunk/UTIL/inifor/src/inifor.f90	(revision 4808)
@@ -85,5 +85,5 @@
 ! Added main loop support for computation of geostrophic winds and surface
 !     pressure
-! Cleaned up terminal output, show some meVssages only with --debug option
+! Cleaned up terminal output, show some messages only with --debug option
 ! 
 ! 3183 2018-07-27 14:25:55Z suehring
Index: palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 4807)
+++ palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 4808)
@@ -214,5 +214,5 @@
     ACHAR( 10 ) // ' Copyright 2017-2020 Deutscher Wetterdienst Offenbach' !< Copyright notice
  CHARACTER(LEN=*), PARAMETER ::  LOG_FILE_NAME = 'inifor.log' !< Name of INIFOR's log file
- CHARACTER(LEN=*), PARAMETER ::  VERSION = '2.1.3'            !< INIFOR version number
+ CHARACTER(LEN=*), PARAMETER ::  VERSION = '2.1.4'            !< INIFOR version number
  
  END MODULE inifor_defs
Index: palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 4807)
+++ palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 4808)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! Temporarily disabling dataset validation, enabling compatibility for HHL
+!    fields without time dimension
+!
+!
+! 4790 2020-11-18 13:05:58Z eckhard
 ! Call dataset validation
 ! Fixed error message
@@ -597,5 +602,5 @@
 ! Section 3: Check for consistency
 !------------------------------------------------------------------------------
-    CALL validate_dataset( flow_files, cfg%hhl_file )
+    !CALL validate_dataset( flow_files, cfg%hhl_file )
 
 !
Index: palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 4807)
+++ palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 4808)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Add offending height values to model-top error message
+!
+!
+! 4756 2020-10-26 10:05:58Z eckhard
 ! Fixed an error in surface pressure extrapolation where the cosmo grid was
 !    misinterpreted as palm grid
@@ -1105,5 +1109,12 @@
              palm_grid%w_verti(i,j,k,1:2) = - 2.0_wp
 
-             message = "PALM-4U grid extends above COSMO-DE model top."
+             message =                                                         &
+                "PALM-4U grid extends above COSMO model top. " //              &
+                "Height of COSMO model top: " //                               &
+                TRIM( real_to_str( column_top, format = '(F11.3)') ) //        &
+                " m, height of current PALM point: " //                        &
+                TRIM( real_to_str( current_height , format = '(F11.3)') ) //   &
+                " m, height of PALM model top: " //                            &
+                TRIM( real_to_str( MAXVAL(palm_grid%z) + palm_grid%z0, '(F11.3)') ) // " m."
              CALL inifor_abort('find_vertical_neighbours_and_weights', message)
 
@@ -1246,5 +1257,12 @@
              avg_grid%w(l,k_palm,1:2) = - 2.0_wp
 
-             message = "PALM-4U grid extends above COSMO-DE model top."
+             message =                                                         &
+                "PALM-4U grid extends above COSMO model top. " //              &
+                "Height of COSMO model top: " //                               &
+                TRIM( real_to_str( column_top, format = '(F11.3)') ) //        &
+                " m, height of current PALM point: " //                        &
+                TRIM( real_to_str( current_height , format = '(F11.3)') ) //   &
+                " m, height of PALM model top: " //                            &
+                TRIM( real_to_str( MAXVAL(avg_grid%z) + avg_grid%z0, '(F11.3)') ) // " m."
              CALL inifor_abort('find_vertical_neighbours_and_weights_average', message)
 