Index: palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- palm/trunk/SCRIPTS/.palm.iofiles	(revision 4781)
+++ palm/trunk/SCRIPTS/.palm.iofiles	(revision 4814)
@@ -1,90 +1,87 @@
 #$Id$
 #
-#---------------------------------------------------------------------------------------------
+#------------------------------------------------------------------------------------------------------------
 # List of input-files
-#---------------------------------------------------------------------------------------------
-PARIN                    in:tr      d3#      $base_data/$run_identifier/INPUT          _p3d*
-PARIN                    in:tr      d3r      $base_data/$run_identifier/INPUT          _p3dr*
-PARIN                    in:tr      pcr      $base_data/$run_identifier/INPUT          _pcr*
-NAVIGATION_DATA          inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _nav*
-TOPOGRAPHY_DATA          inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _topo*
-PLANT_CANOPY_DATA_3D     inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _canopy*
-PIDS_STATIC              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _static*
-PIDS_DYNAMIC             inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _dynamic*
-PIDS_SALSA               inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _salsa*
-PIDS_CHEM                inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _chemistry*
-PIDS_UVEM                inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _uvlookup*
-PIDS_VM                  inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _vmeas*
-PIDS_WTM                 inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _wtmpar*
-rrtmg_lw.nc              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _rlw
-rrtmg_sw.nc              inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _rsw
-WTM_DATA                 inopt:tr   d3#:d3r  $base_data/$run_identifier/INPUT          _wtm
-BININ                    in:lnpe    d3r:rec  $fast_io_catalog/$run_identifier/RESTART  _d3d*
-PARTICLE_RESTART_DATA_IN in:lnpe    prtr     $fast_io_catalog/$run_identifier/RESTART  _rprt
-SVFIN                    in:lnpe    svfin    $fast_io_catalog/$run_identifier/SVF      _svf*
-DATA_1D_FL_NETCDF        inopt      flr      $base_data/$run_identifier/OUTPUT         _fl*       nc
-DATA_1D_PR_NETCDF        inopt      prr      $base_data/$run_identifier/OUTPUT         _pr*       nc
-DATA_1D_SP_NETCDF        inopt      spr      $base_data/$run_identifier/OUTPUT         _sp*       nc
-DATA_1D_TS_NETCDF        inopt      tsr      $base_data/$run_identifier/OUTPUT         _ts*       nc
-DATA_1D_PTS_NETCDF       inopt      ptsr     $base_data/$run_identifier/OUTPUT         _pts*      nc
-DATA_1D_SPTS_NETCDF      inopt      sptsr    $base_data/$run_identifier/OUTPUT         _spts*     nc
-DATA_2D_XY_NETCDF        inopt      xyr      $base_data/$run_identifier/OUTPUT         _xy*       nc
-DATA_2D_XY_AV_NETCDF     inopt      xyr      $base_data/$run_identifier/OUTPUT         _av_xy*    nc
-DATA_2D_XZ_NETCDF        inopt      xzr      $base_data/$run_identifier/OUTPUT         _xz*       nc
-DATA_2D_XZ_AV_NETCDF     inopt      xzr      $base_data/$run_identifier/OUTPUT         _av_xz*    nc
-DATA_2D_YZ_NETCDF        inopt      yzr      $base_data/$run_identifier/OUTPUT         _yz*       nc
-DATA_2D_YZ_AV_NETCDF     inopt      yzr      $base_data/$run_identifier/OUTPUT         _av_yz*    nc
-DATA_3D_NETCDF           inopt      3dr      $base_data/$run_identifier/OUTPUT         _3d*       nc
-DATA_3D_AV_NETCDF        inopt      3dr      $base_data/$run_identifier/OUTPUT         _av_3d*    nc
-DATA_MASK_NETCDF         inopt      mar      $base_data/$run_identifier/OUTPUT         _masked    nc
-DATA_MASK_AV_NETCDF      inopt      mar      $base_data/$run_identifier/OUTPUT         _av_masked nc
-DATA_PRT_NETCDF          inopt:pe   prtr     $base_data/$run_identifier/OUTPUT         _prt*
+#------------------------------------------------------------------------------------------------------------
+PARIN                    in:tr      d3#        $base_data/$run_identifier/INPUT            _p3d*
+PARIN                    in:tr      d3r        $base_data/$run_identifier/INPUT            _p3dr*
+PARIN                    in:tr      pcr        $base_data/$run_identifier/INPUT            _pcr*
+NAVIGATION_DATA          inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _nav*
+TOPOGRAPHY_DATA          inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _topo*
+PLANT_CANOPY_DATA_3D     inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _canopy*
+PIDS_STATIC              inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _static*
+PIDS_DYNAMIC             inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _dynamic*
+PIDS_SALSA               inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _salsa*
+PIDS_CHEM                inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _chemistry*
+PIDS_UVEM                inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _uvlookup*
+PIDS_VM                  inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _vmeas*
+PIDS_WTM                 inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _wtmpar*
+rrtmg_lw.nc              inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _rlw
+rrtmg_sw.nc              inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _rsw
+WTM_DATA                 inopt:tr   d3#:d3r    $base_data/$run_identifier/INPUT            _wtm
+BININ                    in:lnpe    d3r:cyclic $restart_data_path/$run_identifier/RESTART  _d3d*
+PARTICLE_RESTART_DATA_IN in:lnpe    prtr       $restart_data_path/$run_identifier/RESTART  _rprt
+SVFIN                    in:lnpe    svfin      $restart_data_path/$run_identifier/SVF      _svf*
+DATA_1D_FL_NETCDF        inopt      flr        $output_data_path/$run_identifier/OUTPUT    _fl*       nc
+DATA_1D_PR_NETCDF        inopt      prr        $output_data_path/$run_identifier/OUTPUT    _pr*       nc
+DATA_1D_PTS_NETCDF       inopt      ptsr       $output_data_path/$run_identifier/OUTPUT    _pts*      nc
+DATA_1D_SP_NETCDF        inopt      spr        $output_data_path/$run_identifier/OUTPUT    _sp*       nc
+DATA_1D_SPTS_NETCDF      inopt      sptsr      $output_data_path/$run_identifier/OUTPUT    _spts*     nc
+DATA_1D_TS_NETCDF        inopt      tsr        $output_data_path/$run_identifier/OUTPUT    _ts*       nc
+DATA_2D_XY_AV_NETCDF     inopt      xyr        $output_data_path/$run_identifier/OUTPUT    _av_xy*    nc
+DATA_2D_XY_NETCDF        inopt      xyr        $output_data_path/$run_identifier/OUTPUT    _xy*       nc
+DATA_2D_XZ_AV_NETCDF     inopt      xzr        $output_data_path/$run_identifier/OUTPUT    _av_xz*    nc
+DATA_2D_XZ_NETCDF        inopt      xzr        $output_data_path/$run_identifier/OUTPUT    _xz*       nc
+DATA_2D_YZ_AV_NETCDF     inopt      yzr        $output_data_path/$run_identifier/OUTPUT    _av_yz*    nc
+DATA_2D_YZ_NETCDF        inopt      yzr        $output_data_path/$run_identifier/OUTPUT    _yz*       nc
+DATA_3D_NETCDF           inopt      3dr        $output_data_path/$run_identifier/OUTPUT    _3d*       nc
+DATA_3D_AV_NETCDF        inopt      3dr        $output_data_path/$run_identifier/OUTPUT    _av_3d*    nc
+DATA_MASK_AV_NETCDF      inopt      mar        $output_data_path/$run_identifier/OUTPUT    _av_masked nc
+DATA_MASK_NETCDF         inopt      mar        $output_data_path/$run_identifier/OUTPUT    _masked    nc
+#DATA_PRT_NETCDF          inopt:pe   prtr       $output_data_path/$run_identifier/OUTPUT    _prt*      nc
 #
-#---------------------------------------------------------------------------------------------
+#------------------------------------------------------------------------------------------------------------
 # List of output-files
-#---------------------------------------------------------------------------------------------
-BINOUT*                    out:lnpe restart   $fast_io_catalog/$run_identifier/RESTART  _d3d
-PARTICLE_RESTART_DATA_OUT* out:lnpe prt#:prtr $fast_io_catalog/$run_identifier/RESTART  _rprt
-SVFOUT*                    out:lnpe svfout    $fast_io_catalog/$run_identifier/SVF      _svf
+#------------------------------------------------------------------------------------------------------------
+BINOUT*                    out:lnpe restart:pcr $restart_data_path/$run_identifier/RESTART    _d3d
+PARTICLE_RESTART_DATA_OUT* out:lnpe prt#:prtr   $restart_data_path/$run_identifier/RESTART    _rprt
+SVFOUT*                    out:lnpe svfout      $restart_data_path/$run_identifier/SVF        _svf
 #
-STDOUT*                    out:tr   d3#:pcr   $base_data/$run_identifier/MONITORING     _stdout
-STDOUT*                    out:tra  d3r       $base_data/$run_identifier/MONITORING     _stdout
-RUN_CONTROL*               out:tr   d3#:pcr   $base_data/$run_identifier/MONITORING     _rc
-RUN_CONTROL*               out:tra  d3r       $base_data/$run_identifier/MONITORING     _rc
-HEADER*                    out:tr   d3#:pcr   $base_data/$run_identifier/MONITORING     _header
-HEADER*                    out:tra  d3r       $base_data/$run_identifier/MONITORING     _header
-CPU_MEASURES*              out:tr   d3#:pcr   $base_data/$run_identifier/MONITORING     _cpu
-CPU_MEASURES*              out:tra  d3r       $base_data/$run_identifier/MONITORING     _cpu
-PARTICLE_INFO*             out:tr   pt#       $base_data/$run_identifier/MONITORING     _prt_info
-PARTICLE_INFO*             out:tra  ptr       $base_data/$run_identifier/MONITORING     _prt_info
-LIST_PROFIL*               out:tr   *         $base_data/$run_identifier/MONITORING     _list_pr
+PARIN*                     out:tr   d3#:d3r:pcr $output_data_path/$run_identifier/MONITORING  _parin
+STDOUT*                    out:tr   d3#:d3r:pcr $output_data_path/$run_identifier/MONITORING  _stdout
+RUN_CONTROL*               out:tr   d3#:d3r:pcr $output_data_path/$run_identifier/MONITORING  _rc
+HEADER*                    out:tr   d3#:d3r:pcr $output_data_path/$run_identifier/MONITORING  _header
+CPU_MEASURES*              out:tr   d3#:d3r:pcr $output_data_path/$run_identifier/MONITORING  _cpu
+PARTICLE_INFOS*            out:tr   *           $output_data_path/$run_identifier/MONITORING  _prt_info
+LIST_PROFIL*               out:tr   *           $output_data_path/$run_identifier/MONITORING  _list_pr
 #
-SURFACE_DATA_BIN*          out:lnpe *         $base_data/$run_identifier/OUTPUT         _surf
-SURFACE_DATA_AV_BIN*       out:lnpe *         $base_data/$run_identifier/OUTPUT         _av_surf
-SURFACE_DATA_NETCDF*       out:tr   *         $base_data/$run_identifier/OUTPUT         _surf      nc
-SURFACE_DATA_AV_NETCDF*    out:tr   *         $base_data/$run_identifier/OUTPUT         _av_surf   nc
-#
-DATA_1D_FL_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _fl        nc
-DATA_1D_PR_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _pr        nc
-DATA_1D_SP_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _sp        nc
-DATA_1D_TS_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _ts        nc
-DATA_1D_PTS_NETCDF*        out:tr   *         $base_data/$run_identifier/OUTPUT         _pts       nc
-DATA_1D_SPTS_NETCDF*       out:tr   *         $base_data/$run_identifier/OUTPUT         _spts      nc
-DATA_2D_XY_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _xy        nc
-DATA_2D_XY_AV_NETCDF*      out:tr   *         $base_data/$run_identifier/OUTPUT         _av_xy     nc
-DATA_2D_XZ_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _xz        nc
-DATA_2D_XZ_AV_NETCDF*      out:tr   *         $base_data/$run_identifier/OUTPUT         _av_xz     nc
-DATA_2D_YZ_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _yz        nc
-DATA_2D_YZ_AV_NETCDF*      out:tr   *         $base_data/$run_identifier/OUTPUT         _av_yz     nc
-DATA_3D_NETCDF*            out:tr   *         $base_data/$run_identifier/OUTPUT         _3d        nc
-DATA_3D_AV_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _av_3d     nc
-DATA_MASK_NETCDF*          out:tr   *         $base_data/$run_identifier/OUTPUT         _masked    nc
-DATA_MASK_AV_NETCDF*       out:tr   *         $base_data/$run_identifier/OUTPUT         _av_masked nc
-DATA_AGT_NETCDF*           out:tr   *         $base_data/$run_identifier/OUTPUT         _agt       nc
-VM_OUTPUT*                 out:pe   *         $base_data/$run_identifier/OUTPUT         _vm
-#
-DATA_PRT_NETCDF*           out:pe   *         $base_data/$run_identifier/OUTPUT         _prt
-DATA_PRT_NETCDF*           out:trpe *         $base_data/$run_identifier/OUTPUT         _prt
-PARTICLE_DATA*             out:lnpe *         $base_data/$run_identifier/OUTPUT         _prt_dat
-#
-DATA_1D_TS_WTM_NETCDF*     out:tr   *         $base_data/$run_identifier/OUTPUT          _wtm       nc
+DATA_1D_FL_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _fl          nc
+DATA_1D_PR_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _pr          nc
+DATA_1D_PTS_NETCDF*        out:tr   *           $output_data_path/$run_identifier/OUTPUT      _pts         nc
+DATA_1D_SP_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _sp          nc
+DATA_1D_SPTS_NETCDF*       out:tr   *           $output_data_path/$run_identifier/OUTPUT      _spts        nc
+DATA_1D_TS_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _ts          nc
+DATA_1D_TS_WTM_NETCDF*     out:tr   *           $output_data_path/$run_identifier/OUTPUT      _wtm         nc
+DATA_2D_XY_AV_NETCDF*      out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_xy       nc
+DATA_2D_XY_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _xy          nc
+DATA_2D_XZ_AV_NETCDF*      out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_xz       nc
+DATA_2D_XZ_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _xz          nc
+DATA_2D_YZ_AV_NETCDF*      out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_yz       nc
+DATA_2D_YZ_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _yz          nc
+DATA_3D_AV_NETCDF*         out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_3d       nc
+DATA_3D_NETCDF*            out:tr   *           $output_data_path/$run_identifier/OUTPUT      _3d          nc
+DATA_AGT_NETCDF*           out:tr   *           $output_data_path/$run_identifier/OUTPUT      _agt         nc
+DATA_MASK_AV_NETCDF*       out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_masked   nc
+DATA_MASK_NETCDF*          out:tr   *           $output_data_path/$run_identifier/OUTPUT      _masked      nc
+#DATA_PRT_NETCDF*           out:pe   *           $output_data_path/$run_identifier/OUTPUT      _prt         nc
+#DATA_PRT_NETCDF*           out:trpe *           $output_data_path/$run_identifier/OUTPUT      _prt         nc
+PARTICLE_DATA*             out:lnpe *           $output_data_path/$run_identifier/OUTPUT      _prt_bin
+SURFACE_DATA_AV_BIN*       out:lnpe *           $output_data_path/$run_identifier/OUTPUT      _av_surf_bin
+SURFACE_DATA_BIN*          out:lnpe *           $output_data_path/$run_identifier/OUTPUT      _surf_bin
+SURFACE_DATA_AV_NETCDF*    out:tr   *           $output_data_path/$run_identifier/OUTPUT      _av_surf     nc
+SURFACE_DATA_NETCDF*       out:tr   *           $output_data_path/$run_identifier/OUTPUT      _surf        nc
+VM_OUTPUT*                 out:pe   *           $output_data_path/$run_identifier/OUTPUT      _vm
+#------------------------------------------------------------------------------------------------------------
+# Deprecated settings (will be removed in a future revision)
+#------------------------------------------------------------------------------------------------------------
+BININ                      in:lnpe  rec         $restart_data_path/$run_identifier/RESTART  _d3d*